var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.js
var src_exports = {};
__export(src_exports, {
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  default: () => src_default,
  encounter: () => encounter,
  execute: () => execute,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  fn: () => import_language_common2.fn,
  fnIf: () => import_language_common2.fnIf,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  sourceValue: () => import_language_common2.sourceValue
});
module.exports = __toCommonJS(src_exports);

// src/Adaptor.js
var Adaptor_exports = {};
__export(Adaptor_exports, {
  dataPath: () => import_language_common2.dataPath,
  dataValue: () => import_language_common2.dataValue,
  encounter: () => encounter,
  execute: () => execute,
  field: () => import_language_common2.field,
  fields: () => import_language_common2.fields,
  fn: () => import_language_common2.fn,
  fnIf: () => import_language_common2.fnIf,
  lastReferenceValue: () => import_language_common2.lastReferenceValue,
  merge: () => import_language_common2.merge,
  sourceValue: () => import_language_common2.sourceValue
});
var import_language_common = require("@openfn/language-common");

// src/Client.js
var import_superagent = __toESM(require("superagent"), 1);
function post({ username, password, body, url }) {
  return new Promise((resolve, reject) => {
    import_superagent.default.post(url).type("json").accept("json").auth(username, password).send(JSON.stringify(body)).end((error, res) => {
      if (!!error || !res.ok) {
        reject(error);
      }
      resolve(res);
    });
  });
}

// src/Adaptor.js
var import_url = require("url");
var import_language_common2 = require("@openfn/language-common");
function execute(...operations) {
  const initialState = {
    references: [],
    data: null
  };
  return (state) => {
    return (0, import_language_common.execute)(...operations)({ ...initialState, ...state });
  };
}
function encounter(encounterData) {
  return (state) => {
    const body = (0, import_language_common.expandReferences)(encounterData)(state);
    const { username, password, apiUrl } = state.configuration;
    const url = (0, import_url.resolve)(apiUrl + "/", "chw/encounter");
    console.log("Posting encounter:");
    console.log(JSON.stringify(body, null, 2));
    return post({ username, password, body, url }).then((result) => {
      console.log("Success:", result);
      return { ...state, references: [result, ...state.references] };
    });
  };
}

// src/index.js
var src_default = Adaptor_exports;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  dataPath,
  dataValue,
  encounter,
  execute,
  field,
  fields,
  fn,
  fnIf,
  lastReferenceValue,
  merge,
  sourceValue
});
