var __defProp = Object.defineProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};

// src/Adaptor.js
var Adaptor_exports = {};
__export(Adaptor_exports, {
  dataPath: () => dataPath,
  dataValue: () => dataValue,
  encounter: () => encounter,
  execute: () => execute,
  field: () => field,
  fields: () => fields,
  fn: () => fn,
  fnIf: () => fnIf,
  lastReferenceValue: () => lastReferenceValue,
  merge: () => merge,
  sourceValue: () => sourceValue
});
import {
  execute as commonExecute,
  expandReferences
} from "@openfn/language-common";

// src/Client.js
import request from "superagent";
function post({ username, password, body, url }) {
  return new Promise((resolve, reject) => {
    request.post(url).type("json").accept("json").auth(username, password).send(JSON.stringify(body)).end((error, res) => {
      if (!!error || !res.ok) {
        reject(error);
      }
      resolve(res);
    });
  });
}

// src/Adaptor.js
import { resolve as resolveUrl } from "url";
import {
  fn,
  fnIf,
  field,
  fields,
  sourceValue,
  merge,
  dataPath,
  dataValue,
  lastReferenceValue
} from "@openfn/language-common";
function execute(...operations) {
  const initialState = {
    references: [],
    data: null
  };
  return (state) => {
    return commonExecute(...operations)({ ...initialState, ...state });
  };
}
function encounter(encounterData) {
  return (state) => {
    const body = expandReferences(encounterData)(state);
    const { username, password, apiUrl } = state.configuration;
    const url = resolveUrl(apiUrl + "/", "chw/encounter");
    console.log("Posting encounter:");
    console.log(JSON.stringify(body, null, 2));
    return post({ username, password, body, url }).then((result) => {
      console.log("Success:", result);
      return { ...state, references: [result, ...state.references] };
    });
  };
}

// src/index.js
var src_default = Adaptor_exports;
export {
  dataPath,
  dataValue,
  src_default as default,
  encounter,
  execute,
  field,
  fields,
  fn,
  fnIf,
  lastReferenceValue,
  merge,
  sourceValue
};
